// Code generated by ent, DO NOT EDIT.

package batchmsg

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldDeletedAt, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStatus, v))
}

// BatchNo applies equality check predicate on the "batch_no" field. It's identical to BatchNoEQ.
func BatchNo(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldBatchNo, v))
}

// TaskName applies equality check predicate on the "task_name" field. It's identical to TaskNameEQ.
func TaskName(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTaskName, v))
}

// Fromwxid applies equality check predicate on the "fromwxid" field. It's identical to FromwxidEQ.
func Fromwxid(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldFromwxid, v))
}

// Msg applies equality check predicate on the "msg" field. It's identical to MsgEQ.
func Msg(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldMsg, v))
}

// Tag applies equality check predicate on the "tag" field. It's identical to TagEQ.
func Tag(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTag, v))
}

// Tagids applies equality check predicate on the "tagids" field. It's identical to TagidsEQ.
func Tagids(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTagids, v))
}

// Total applies equality check predicate on the "total" field. It's identical to TotalEQ.
func Total(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTotal, v))
}

// Success applies equality check predicate on the "success" field. It's identical to SuccessEQ.
func Success(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldSuccess, v))
}

// Fail applies equality check predicate on the "fail" field. It's identical to FailEQ.
func Fail(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldFail, v))
}

// StartTime applies equality check predicate on the "start_time" field. It's identical to StartTimeEQ.
func StartTime(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStartTime, v))
}

// StopTime applies equality check predicate on the "stop_time" field. It's identical to StopTimeEQ.
func StopTime(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStopTime, v))
}

// SendTime applies equality check predicate on the "send_time" field. It's identical to SendTimeEQ.
func SendTime(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldSendTime, v))
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldType, v))
}

// OrganizationID applies equality check predicate on the "organization_id" field. It's identical to OrganizationIDEQ.
func OrganizationID(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldOrganizationID, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldDeletedAt))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v uint8) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldStatus))
}

// BatchNoEQ applies the EQ predicate on the "batch_no" field.
func BatchNoEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldBatchNo, v))
}

// BatchNoNEQ applies the NEQ predicate on the "batch_no" field.
func BatchNoNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldBatchNo, v))
}

// BatchNoIn applies the In predicate on the "batch_no" field.
func BatchNoIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldBatchNo, vs...))
}

// BatchNoNotIn applies the NotIn predicate on the "batch_no" field.
func BatchNoNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldBatchNo, vs...))
}

// BatchNoGT applies the GT predicate on the "batch_no" field.
func BatchNoGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldBatchNo, v))
}

// BatchNoGTE applies the GTE predicate on the "batch_no" field.
func BatchNoGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldBatchNo, v))
}

// BatchNoLT applies the LT predicate on the "batch_no" field.
func BatchNoLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldBatchNo, v))
}

// BatchNoLTE applies the LTE predicate on the "batch_no" field.
func BatchNoLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldBatchNo, v))
}

// BatchNoContains applies the Contains predicate on the "batch_no" field.
func BatchNoContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldBatchNo, v))
}

// BatchNoHasPrefix applies the HasPrefix predicate on the "batch_no" field.
func BatchNoHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldBatchNo, v))
}

// BatchNoHasSuffix applies the HasSuffix predicate on the "batch_no" field.
func BatchNoHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldBatchNo, v))
}

// BatchNoIsNil applies the IsNil predicate on the "batch_no" field.
func BatchNoIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldBatchNo))
}

// BatchNoNotNil applies the NotNil predicate on the "batch_no" field.
func BatchNoNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldBatchNo))
}

// BatchNoEqualFold applies the EqualFold predicate on the "batch_no" field.
func BatchNoEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldBatchNo, v))
}

// BatchNoContainsFold applies the ContainsFold predicate on the "batch_no" field.
func BatchNoContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldBatchNo, v))
}

// TaskNameEQ applies the EQ predicate on the "task_name" field.
func TaskNameEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTaskName, v))
}

// TaskNameNEQ applies the NEQ predicate on the "task_name" field.
func TaskNameNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldTaskName, v))
}

// TaskNameIn applies the In predicate on the "task_name" field.
func TaskNameIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldTaskName, vs...))
}

// TaskNameNotIn applies the NotIn predicate on the "task_name" field.
func TaskNameNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldTaskName, vs...))
}

// TaskNameGT applies the GT predicate on the "task_name" field.
func TaskNameGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldTaskName, v))
}

// TaskNameGTE applies the GTE predicate on the "task_name" field.
func TaskNameGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldTaskName, v))
}

// TaskNameLT applies the LT predicate on the "task_name" field.
func TaskNameLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldTaskName, v))
}

// TaskNameLTE applies the LTE predicate on the "task_name" field.
func TaskNameLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldTaskName, v))
}

// TaskNameContains applies the Contains predicate on the "task_name" field.
func TaskNameContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldTaskName, v))
}

// TaskNameHasPrefix applies the HasPrefix predicate on the "task_name" field.
func TaskNameHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldTaskName, v))
}

// TaskNameHasSuffix applies the HasSuffix predicate on the "task_name" field.
func TaskNameHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldTaskName, v))
}

// TaskNameIsNil applies the IsNil predicate on the "task_name" field.
func TaskNameIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldTaskName))
}

// TaskNameNotNil applies the NotNil predicate on the "task_name" field.
func TaskNameNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldTaskName))
}

// TaskNameEqualFold applies the EqualFold predicate on the "task_name" field.
func TaskNameEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldTaskName, v))
}

// TaskNameContainsFold applies the ContainsFold predicate on the "task_name" field.
func TaskNameContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldTaskName, v))
}

// FromwxidEQ applies the EQ predicate on the "fromwxid" field.
func FromwxidEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldFromwxid, v))
}

// FromwxidNEQ applies the NEQ predicate on the "fromwxid" field.
func FromwxidNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldFromwxid, v))
}

// FromwxidIn applies the In predicate on the "fromwxid" field.
func FromwxidIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldFromwxid, vs...))
}

// FromwxidNotIn applies the NotIn predicate on the "fromwxid" field.
func FromwxidNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldFromwxid, vs...))
}

// FromwxidGT applies the GT predicate on the "fromwxid" field.
func FromwxidGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldFromwxid, v))
}

// FromwxidGTE applies the GTE predicate on the "fromwxid" field.
func FromwxidGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldFromwxid, v))
}

// FromwxidLT applies the LT predicate on the "fromwxid" field.
func FromwxidLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldFromwxid, v))
}

// FromwxidLTE applies the LTE predicate on the "fromwxid" field.
func FromwxidLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldFromwxid, v))
}

// FromwxidContains applies the Contains predicate on the "fromwxid" field.
func FromwxidContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldFromwxid, v))
}

// FromwxidHasPrefix applies the HasPrefix predicate on the "fromwxid" field.
func FromwxidHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldFromwxid, v))
}

// FromwxidHasSuffix applies the HasSuffix predicate on the "fromwxid" field.
func FromwxidHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldFromwxid, v))
}

// FromwxidIsNil applies the IsNil predicate on the "fromwxid" field.
func FromwxidIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldFromwxid))
}

// FromwxidNotNil applies the NotNil predicate on the "fromwxid" field.
func FromwxidNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldFromwxid))
}

// FromwxidEqualFold applies the EqualFold predicate on the "fromwxid" field.
func FromwxidEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldFromwxid, v))
}

// FromwxidContainsFold applies the ContainsFold predicate on the "fromwxid" field.
func FromwxidContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldFromwxid, v))
}

// MsgEQ applies the EQ predicate on the "msg" field.
func MsgEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldMsg, v))
}

// MsgNEQ applies the NEQ predicate on the "msg" field.
func MsgNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldMsg, v))
}

// MsgIn applies the In predicate on the "msg" field.
func MsgIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldMsg, vs...))
}

// MsgNotIn applies the NotIn predicate on the "msg" field.
func MsgNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldMsg, vs...))
}

// MsgGT applies the GT predicate on the "msg" field.
func MsgGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldMsg, v))
}

// MsgGTE applies the GTE predicate on the "msg" field.
func MsgGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldMsg, v))
}

// MsgLT applies the LT predicate on the "msg" field.
func MsgLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldMsg, v))
}

// MsgLTE applies the LTE predicate on the "msg" field.
func MsgLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldMsg, v))
}

// MsgContains applies the Contains predicate on the "msg" field.
func MsgContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldMsg, v))
}

// MsgHasPrefix applies the HasPrefix predicate on the "msg" field.
func MsgHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldMsg, v))
}

// MsgHasSuffix applies the HasSuffix predicate on the "msg" field.
func MsgHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldMsg, v))
}

// MsgIsNil applies the IsNil predicate on the "msg" field.
func MsgIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldMsg))
}

// MsgNotNil applies the NotNil predicate on the "msg" field.
func MsgNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldMsg))
}

// MsgEqualFold applies the EqualFold predicate on the "msg" field.
func MsgEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldMsg, v))
}

// MsgContainsFold applies the ContainsFold predicate on the "msg" field.
func MsgContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldMsg, v))
}

// TagEQ applies the EQ predicate on the "tag" field.
func TagEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTag, v))
}

// TagNEQ applies the NEQ predicate on the "tag" field.
func TagNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldTag, v))
}

// TagIn applies the In predicate on the "tag" field.
func TagIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldTag, vs...))
}

// TagNotIn applies the NotIn predicate on the "tag" field.
func TagNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldTag, vs...))
}

// TagGT applies the GT predicate on the "tag" field.
func TagGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldTag, v))
}

// TagGTE applies the GTE predicate on the "tag" field.
func TagGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldTag, v))
}

// TagLT applies the LT predicate on the "tag" field.
func TagLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldTag, v))
}

// TagLTE applies the LTE predicate on the "tag" field.
func TagLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldTag, v))
}

// TagContains applies the Contains predicate on the "tag" field.
func TagContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldTag, v))
}

// TagHasPrefix applies the HasPrefix predicate on the "tag" field.
func TagHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldTag, v))
}

// TagHasSuffix applies the HasSuffix predicate on the "tag" field.
func TagHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldTag, v))
}

// TagIsNil applies the IsNil predicate on the "tag" field.
func TagIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldTag))
}

// TagNotNil applies the NotNil predicate on the "tag" field.
func TagNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldTag))
}

// TagEqualFold applies the EqualFold predicate on the "tag" field.
func TagEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldTag, v))
}

// TagContainsFold applies the ContainsFold predicate on the "tag" field.
func TagContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldTag, v))
}

// TagidsEQ applies the EQ predicate on the "tagids" field.
func TagidsEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTagids, v))
}

// TagidsNEQ applies the NEQ predicate on the "tagids" field.
func TagidsNEQ(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldTagids, v))
}

// TagidsIn applies the In predicate on the "tagids" field.
func TagidsIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldTagids, vs...))
}

// TagidsNotIn applies the NotIn predicate on the "tagids" field.
func TagidsNotIn(vs ...string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldTagids, vs...))
}

// TagidsGT applies the GT predicate on the "tagids" field.
func TagidsGT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldTagids, v))
}

// TagidsGTE applies the GTE predicate on the "tagids" field.
func TagidsGTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldTagids, v))
}

// TagidsLT applies the LT predicate on the "tagids" field.
func TagidsLT(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldTagids, v))
}

// TagidsLTE applies the LTE predicate on the "tagids" field.
func TagidsLTE(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldTagids, v))
}

// TagidsContains applies the Contains predicate on the "tagids" field.
func TagidsContains(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContains(FieldTagids, v))
}

// TagidsHasPrefix applies the HasPrefix predicate on the "tagids" field.
func TagidsHasPrefix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasPrefix(FieldTagids, v))
}

// TagidsHasSuffix applies the HasSuffix predicate on the "tagids" field.
func TagidsHasSuffix(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldHasSuffix(FieldTagids, v))
}

// TagidsIsNil applies the IsNil predicate on the "tagids" field.
func TagidsIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldTagids))
}

// TagidsNotNil applies the NotNil predicate on the "tagids" field.
func TagidsNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldTagids))
}

// TagidsEqualFold applies the EqualFold predicate on the "tagids" field.
func TagidsEqualFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEqualFold(FieldTagids, v))
}

// TagidsContainsFold applies the ContainsFold predicate on the "tagids" field.
func TagidsContainsFold(v string) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldContainsFold(FieldTagids, v))
}

// TotalEQ applies the EQ predicate on the "total" field.
func TotalEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldTotal, v))
}

// TotalNEQ applies the NEQ predicate on the "total" field.
func TotalNEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldTotal, v))
}

// TotalIn applies the In predicate on the "total" field.
func TotalIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldTotal, vs...))
}

// TotalNotIn applies the NotIn predicate on the "total" field.
func TotalNotIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldTotal, vs...))
}

// TotalGT applies the GT predicate on the "total" field.
func TotalGT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldTotal, v))
}

// TotalGTE applies the GTE predicate on the "total" field.
func TotalGTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldTotal, v))
}

// TotalLT applies the LT predicate on the "total" field.
func TotalLT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldTotal, v))
}

// TotalLTE applies the LTE predicate on the "total" field.
func TotalLTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldTotal, v))
}

// TotalIsNil applies the IsNil predicate on the "total" field.
func TotalIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldTotal))
}

// TotalNotNil applies the NotNil predicate on the "total" field.
func TotalNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldTotal))
}

// SuccessEQ applies the EQ predicate on the "success" field.
func SuccessEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldSuccess, v))
}

// SuccessNEQ applies the NEQ predicate on the "success" field.
func SuccessNEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldSuccess, v))
}

// SuccessIn applies the In predicate on the "success" field.
func SuccessIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldSuccess, vs...))
}

// SuccessNotIn applies the NotIn predicate on the "success" field.
func SuccessNotIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldSuccess, vs...))
}

// SuccessGT applies the GT predicate on the "success" field.
func SuccessGT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldSuccess, v))
}

// SuccessGTE applies the GTE predicate on the "success" field.
func SuccessGTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldSuccess, v))
}

// SuccessLT applies the LT predicate on the "success" field.
func SuccessLT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldSuccess, v))
}

// SuccessLTE applies the LTE predicate on the "success" field.
func SuccessLTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldSuccess, v))
}

// SuccessIsNil applies the IsNil predicate on the "success" field.
func SuccessIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldSuccess))
}

// SuccessNotNil applies the NotNil predicate on the "success" field.
func SuccessNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldSuccess))
}

// FailEQ applies the EQ predicate on the "fail" field.
func FailEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldFail, v))
}

// FailNEQ applies the NEQ predicate on the "fail" field.
func FailNEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldFail, v))
}

// FailIn applies the In predicate on the "fail" field.
func FailIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldFail, vs...))
}

// FailNotIn applies the NotIn predicate on the "fail" field.
func FailNotIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldFail, vs...))
}

// FailGT applies the GT predicate on the "fail" field.
func FailGT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldFail, v))
}

// FailGTE applies the GTE predicate on the "fail" field.
func FailGTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldFail, v))
}

// FailLT applies the LT predicate on the "fail" field.
func FailLT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldFail, v))
}

// FailLTE applies the LTE predicate on the "fail" field.
func FailLTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldFail, v))
}

// FailIsNil applies the IsNil predicate on the "fail" field.
func FailIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldFail))
}

// FailNotNil applies the NotNil predicate on the "fail" field.
func FailNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldFail))
}

// StartTimeEQ applies the EQ predicate on the "start_time" field.
func StartTimeEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStartTime, v))
}

// StartTimeNEQ applies the NEQ predicate on the "start_time" field.
func StartTimeNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldStartTime, v))
}

// StartTimeIn applies the In predicate on the "start_time" field.
func StartTimeIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldStartTime, vs...))
}

// StartTimeNotIn applies the NotIn predicate on the "start_time" field.
func StartTimeNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldStartTime, vs...))
}

// StartTimeGT applies the GT predicate on the "start_time" field.
func StartTimeGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldStartTime, v))
}

// StartTimeGTE applies the GTE predicate on the "start_time" field.
func StartTimeGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldStartTime, v))
}

// StartTimeLT applies the LT predicate on the "start_time" field.
func StartTimeLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldStartTime, v))
}

// StartTimeLTE applies the LTE predicate on the "start_time" field.
func StartTimeLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldStartTime, v))
}

// StartTimeIsNil applies the IsNil predicate on the "start_time" field.
func StartTimeIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldStartTime))
}

// StartTimeNotNil applies the NotNil predicate on the "start_time" field.
func StartTimeNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldStartTime))
}

// StopTimeEQ applies the EQ predicate on the "stop_time" field.
func StopTimeEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldStopTime, v))
}

// StopTimeNEQ applies the NEQ predicate on the "stop_time" field.
func StopTimeNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldStopTime, v))
}

// StopTimeIn applies the In predicate on the "stop_time" field.
func StopTimeIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldStopTime, vs...))
}

// StopTimeNotIn applies the NotIn predicate on the "stop_time" field.
func StopTimeNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldStopTime, vs...))
}

// StopTimeGT applies the GT predicate on the "stop_time" field.
func StopTimeGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldStopTime, v))
}

// StopTimeGTE applies the GTE predicate on the "stop_time" field.
func StopTimeGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldStopTime, v))
}

// StopTimeLT applies the LT predicate on the "stop_time" field.
func StopTimeLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldStopTime, v))
}

// StopTimeLTE applies the LTE predicate on the "stop_time" field.
func StopTimeLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldStopTime, v))
}

// StopTimeIsNil applies the IsNil predicate on the "stop_time" field.
func StopTimeIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldStopTime))
}

// StopTimeNotNil applies the NotNil predicate on the "stop_time" field.
func StopTimeNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldStopTime))
}

// SendTimeEQ applies the EQ predicate on the "send_time" field.
func SendTimeEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldSendTime, v))
}

// SendTimeNEQ applies the NEQ predicate on the "send_time" field.
func SendTimeNEQ(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldSendTime, v))
}

// SendTimeIn applies the In predicate on the "send_time" field.
func SendTimeIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldSendTime, vs...))
}

// SendTimeNotIn applies the NotIn predicate on the "send_time" field.
func SendTimeNotIn(vs ...time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldSendTime, vs...))
}

// SendTimeGT applies the GT predicate on the "send_time" field.
func SendTimeGT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldSendTime, v))
}

// SendTimeGTE applies the GTE predicate on the "send_time" field.
func SendTimeGTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldSendTime, v))
}

// SendTimeLT applies the LT predicate on the "send_time" field.
func SendTimeLT(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldSendTime, v))
}

// SendTimeLTE applies the LTE predicate on the "send_time" field.
func SendTimeLTE(v time.Time) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldSendTime, v))
}

// SendTimeIsNil applies the IsNil predicate on the "send_time" field.
func SendTimeIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldSendTime))
}

// SendTimeNotNil applies the NotNil predicate on the "send_time" field.
func SendTimeNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldSendTime))
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldType, v))
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldType, v))
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldType, vs...))
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldType, vs...))
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldType, v))
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldType, v))
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldType, v))
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v int32) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldType, v))
}

// TypeIsNil applies the IsNil predicate on the "type" field.
func TypeIsNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIsNull(FieldType))
}

// TypeNotNil applies the NotNil predicate on the "type" field.
func TypeNotNil() predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotNull(FieldType))
}

// OrganizationIDEQ applies the EQ predicate on the "organization_id" field.
func OrganizationIDEQ(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldEQ(FieldOrganizationID, v))
}

// OrganizationIDNEQ applies the NEQ predicate on the "organization_id" field.
func OrganizationIDNEQ(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNEQ(FieldOrganizationID, v))
}

// OrganizationIDIn applies the In predicate on the "organization_id" field.
func OrganizationIDIn(vs ...uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldIn(FieldOrganizationID, vs...))
}

// OrganizationIDNotIn applies the NotIn predicate on the "organization_id" field.
func OrganizationIDNotIn(vs ...uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldNotIn(FieldOrganizationID, vs...))
}

// OrganizationIDGT applies the GT predicate on the "organization_id" field.
func OrganizationIDGT(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGT(FieldOrganizationID, v))
}

// OrganizationIDGTE applies the GTE predicate on the "organization_id" field.
func OrganizationIDGTE(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldGTE(FieldOrganizationID, v))
}

// OrganizationIDLT applies the LT predicate on the "organization_id" field.
func OrganizationIDLT(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLT(FieldOrganizationID, v))
}

// OrganizationIDLTE applies the LTE predicate on the "organization_id" field.
func OrganizationIDLTE(v uint64) predicate.BatchMsg {
	return predicate.BatchMsg(sql.FieldLTE(FieldOrganizationID, v))
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.BatchMsg) predicate.BatchMsg {
	return predicate.BatchMsg(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.BatchMsg) predicate.BatchMsg {
	return predicate.BatchMsg(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.BatchMsg) predicate.BatchMsg {
	return predicate.BatchMsg(sql.NotPredicates(p))
}
