// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"
	"wechat-api/ent/employee"
	"wechat-api/ent/predicate"
	"wechat-api/ent/tutorial"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// TutorialQuery is the builder for querying Tutorial entities.
type TutorialQuery struct {
	config
	ctx          *QueryContext
	order        []tutorial.OrderOption
	inters       []Interceptor
	predicates   []predicate.Tutorial
	withEmployee *EmployeeQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the TutorialQuery builder.
func (tq *TutorialQuery) Where(ps ...predicate.Tutorial) *TutorialQuery {
	tq.predicates = append(tq.predicates, ps...)
	return tq
}

// Limit the number of records to be returned by this query.
func (tq *TutorialQuery) Limit(limit int) *TutorialQuery {
	tq.ctx.Limit = &limit
	return tq
}

// Offset to start from.
func (tq *TutorialQuery) Offset(offset int) *TutorialQuery {
	tq.ctx.Offset = &offset
	return tq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (tq *TutorialQuery) Unique(unique bool) *TutorialQuery {
	tq.ctx.Unique = &unique
	return tq
}

// Order specifies how the records should be ordered.
func (tq *TutorialQuery) Order(o ...tutorial.OrderOption) *TutorialQuery {
	tq.order = append(tq.order, o...)
	return tq
}

// QueryEmployee chains the current query on the "employee" edge.
func (tq *TutorialQuery) QueryEmployee() *EmployeeQuery {
	query := (&EmployeeClient{config: tq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := tq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := tq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(tutorial.Table, tutorial.FieldID, selector),
			sqlgraph.To(employee.Table, employee.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, tutorial.EmployeeTable, tutorial.EmployeeColumn),
		)
		fromU = sqlgraph.SetNeighbors(tq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Tutorial entity from the query.
// Returns a *NotFoundError when no Tutorial was found.
func (tq *TutorialQuery) First(ctx context.Context) (*Tutorial, error) {
	nodes, err := tq.Limit(1).All(setContextOp(ctx, tq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{tutorial.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (tq *TutorialQuery) FirstX(ctx context.Context) *Tutorial {
	node, err := tq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Tutorial ID from the query.
// Returns a *NotFoundError when no Tutorial ID was found.
func (tq *TutorialQuery) FirstID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = tq.Limit(1).IDs(setContextOp(ctx, tq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{tutorial.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (tq *TutorialQuery) FirstIDX(ctx context.Context) uint64 {
	id, err := tq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Tutorial entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Tutorial entity is found.
// Returns a *NotFoundError when no Tutorial entities are found.
func (tq *TutorialQuery) Only(ctx context.Context) (*Tutorial, error) {
	nodes, err := tq.Limit(2).All(setContextOp(ctx, tq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{tutorial.Label}
	default:
		return nil, &NotSingularError{tutorial.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (tq *TutorialQuery) OnlyX(ctx context.Context) *Tutorial {
	node, err := tq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Tutorial ID in the query.
// Returns a *NotSingularError when more than one Tutorial ID is found.
// Returns a *NotFoundError when no entities are found.
func (tq *TutorialQuery) OnlyID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = tq.Limit(2).IDs(setContextOp(ctx, tq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{tutorial.Label}
	default:
		err = &NotSingularError{tutorial.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (tq *TutorialQuery) OnlyIDX(ctx context.Context) uint64 {
	id, err := tq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Tutorials.
func (tq *TutorialQuery) All(ctx context.Context) ([]*Tutorial, error) {
	ctx = setContextOp(ctx, tq.ctx, "All")
	if err := tq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Tutorial, *TutorialQuery]()
	return withInterceptors[[]*Tutorial](ctx, tq, qr, tq.inters)
}

// AllX is like All, but panics if an error occurs.
func (tq *TutorialQuery) AllX(ctx context.Context) []*Tutorial {
	nodes, err := tq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Tutorial IDs.
func (tq *TutorialQuery) IDs(ctx context.Context) (ids []uint64, err error) {
	if tq.ctx.Unique == nil && tq.path != nil {
		tq.Unique(true)
	}
	ctx = setContextOp(ctx, tq.ctx, "IDs")
	if err = tq.Select(tutorial.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (tq *TutorialQuery) IDsX(ctx context.Context) []uint64 {
	ids, err := tq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (tq *TutorialQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, tq.ctx, "Count")
	if err := tq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, tq, querierCount[*TutorialQuery](), tq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (tq *TutorialQuery) CountX(ctx context.Context) int {
	count, err := tq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (tq *TutorialQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, tq.ctx, "Exist")
	switch _, err := tq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (tq *TutorialQuery) ExistX(ctx context.Context) bool {
	exist, err := tq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the TutorialQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (tq *TutorialQuery) Clone() *TutorialQuery {
	if tq == nil {
		return nil
	}
	return &TutorialQuery{
		config:       tq.config,
		ctx:          tq.ctx.Clone(),
		order:        append([]tutorial.OrderOption{}, tq.order...),
		inters:       append([]Interceptor{}, tq.inters...),
		predicates:   append([]predicate.Tutorial{}, tq.predicates...),
		withEmployee: tq.withEmployee.Clone(),
		// clone intermediate query.
		sql:  tq.sql.Clone(),
		path: tq.path,
	}
}

// WithEmployee tells the query-builder to eager-load the nodes that are connected to
// the "employee" edge. The optional arguments are used to configure the query builder of the edge.
func (tq *TutorialQuery) WithEmployee(opts ...func(*EmployeeQuery)) *TutorialQuery {
	query := (&EmployeeClient{config: tq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	tq.withEmployee = query
	return tq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Tutorial.Query().
//		GroupBy(tutorial.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (tq *TutorialQuery) GroupBy(field string, fields ...string) *TutorialGroupBy {
	tq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &TutorialGroupBy{build: tq}
	grbuild.flds = &tq.ctx.Fields
	grbuild.label = tutorial.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.Tutorial.Query().
//		Select(tutorial.FieldCreatedAt).
//		Scan(ctx, &v)
func (tq *TutorialQuery) Select(fields ...string) *TutorialSelect {
	tq.ctx.Fields = append(tq.ctx.Fields, fields...)
	sbuild := &TutorialSelect{TutorialQuery: tq}
	sbuild.label = tutorial.Label
	sbuild.flds, sbuild.scan = &tq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a TutorialSelect configured with the given aggregations.
func (tq *TutorialQuery) Aggregate(fns ...AggregateFunc) *TutorialSelect {
	return tq.Select().Aggregate(fns...)
}

func (tq *TutorialQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range tq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, tq); err != nil {
				return err
			}
		}
	}
	for _, f := range tq.ctx.Fields {
		if !tutorial.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if tq.path != nil {
		prev, err := tq.path(ctx)
		if err != nil {
			return err
		}
		tq.sql = prev
	}
	return nil
}

func (tq *TutorialQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Tutorial, error) {
	var (
		nodes       = []*Tutorial{}
		_spec       = tq.querySpec()
		loadedTypes = [1]bool{
			tq.withEmployee != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Tutorial).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Tutorial{config: tq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, tq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := tq.withEmployee; query != nil {
		if err := tq.loadEmployee(ctx, query, nodes, nil,
			func(n *Tutorial, e *Employee) { n.Edges.Employee = e }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (tq *TutorialQuery) loadEmployee(ctx context.Context, query *EmployeeQuery, nodes []*Tutorial, init func(*Tutorial), assign func(*Tutorial, *Employee)) error {
	ids := make([]uint64, 0, len(nodes))
	nodeids := make(map[uint64][]*Tutorial)
	for i := range nodes {
		fk := nodes[i].EmployeeID
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(employee.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "employee_id" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}

func (tq *TutorialQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := tq.querySpec()
	_spec.Node.Columns = tq.ctx.Fields
	if len(tq.ctx.Fields) > 0 {
		_spec.Unique = tq.ctx.Unique != nil && *tq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, tq.driver, _spec)
}

func (tq *TutorialQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(tutorial.Table, tutorial.Columns, sqlgraph.NewFieldSpec(tutorial.FieldID, field.TypeUint64))
	_spec.From = tq.sql
	if unique := tq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if tq.path != nil {
		_spec.Unique = true
	}
	if fields := tq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, tutorial.FieldID)
		for i := range fields {
			if fields[i] != tutorial.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
		if tq.withEmployee != nil {
			_spec.Node.AddColumnOnce(tutorial.FieldEmployeeID)
		}
	}
	if ps := tq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := tq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := tq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := tq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (tq *TutorialQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(tq.driver.Dialect())
	t1 := builder.Table(tutorial.Table)
	columns := tq.ctx.Fields
	if len(columns) == 0 {
		columns = tutorial.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if tq.sql != nil {
		selector = tq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if tq.ctx.Unique != nil && *tq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range tq.predicates {
		p(selector)
	}
	for _, p := range tq.order {
		p(selector)
	}
	if offset := tq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := tq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// TutorialGroupBy is the group-by builder for Tutorial entities.
type TutorialGroupBy struct {
	selector
	build *TutorialQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (tgb *TutorialGroupBy) Aggregate(fns ...AggregateFunc) *TutorialGroupBy {
	tgb.fns = append(tgb.fns, fns...)
	return tgb
}

// Scan applies the selector query and scans the result into the given value.
func (tgb *TutorialGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, tgb.build.ctx, "GroupBy")
	if err := tgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*TutorialQuery, *TutorialGroupBy](ctx, tgb.build, tgb, tgb.build.inters, v)
}

func (tgb *TutorialGroupBy) sqlScan(ctx context.Context, root *TutorialQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(tgb.fns))
	for _, fn := range tgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*tgb.flds)+len(tgb.fns))
		for _, f := range *tgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*tgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := tgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// TutorialSelect is the builder for selecting fields of Tutorial entities.
type TutorialSelect struct {
	*TutorialQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ts *TutorialSelect) Aggregate(fns ...AggregateFunc) *TutorialSelect {
	ts.fns = append(ts.fns, fns...)
	return ts
}

// Scan applies the selector query and scans the result into the given value.
func (ts *TutorialSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ts.ctx, "Select")
	if err := ts.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*TutorialQuery, *TutorialSelect](ctx, ts.TutorialQuery, ts, ts.inters, v)
}

func (ts *TutorialSelect) sqlScan(ctx context.Context, root *TutorialQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ts.fns))
	for _, fn := range ts.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ts.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ts.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
