// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"
	"wechat-api/ent/wxcardvisit"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// WxCardVisit is the model entity for the WxCardVisit schema.
type WxCardVisit struct {
	config `json:"-"`
	// ID of the ent.
	ID uint64 `json:"id,omitempty"`
	// Create Time | 创建日期
	CreatedAt time.Time `json:"created_at,omitempty"`
	// Update Time | 修改日期
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// Delete Time | 删除日期
	DeletedAt time.Time `json:"deleted_at,omitempty"`
	// user表ID
	UserID uint64 `json:"user_id,omitempty"`
	// 被访ID
	BotID uint64 `json:"bot_id,omitempty"`
	// 类型:1-微信 2-小程序 3-智能体
	BotType      uint8 `json:"bot_type,omitempty"`
	selectValues sql.SelectValues
}

// scanValues returns the types for scanning values from sql.Rows.
func (*WxCardVisit) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case wxcardvisit.FieldID, wxcardvisit.FieldUserID, wxcardvisit.FieldBotID, wxcardvisit.FieldBotType:
			values[i] = new(sql.NullInt64)
		case wxcardvisit.FieldCreatedAt, wxcardvisit.FieldUpdatedAt, wxcardvisit.FieldDeletedAt:
			values[i] = new(sql.NullTime)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the WxCardVisit fields.
func (wcv *WxCardVisit) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case wxcardvisit.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			wcv.ID = uint64(value.Int64)
		case wxcardvisit.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				wcv.CreatedAt = value.Time
			}
		case wxcardvisit.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				wcv.UpdatedAt = value.Time
			}
		case wxcardvisit.FieldDeletedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field deleted_at", values[i])
			} else if value.Valid {
				wcv.DeletedAt = value.Time
			}
		case wxcardvisit.FieldUserID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field user_id", values[i])
			} else if value.Valid {
				wcv.UserID = uint64(value.Int64)
			}
		case wxcardvisit.FieldBotID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field bot_id", values[i])
			} else if value.Valid {
				wcv.BotID = uint64(value.Int64)
			}
		case wxcardvisit.FieldBotType:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field bot_type", values[i])
			} else if value.Valid {
				wcv.BotType = uint8(value.Int64)
			}
		default:
			wcv.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the WxCardVisit.
// This includes values selected through modifiers, order, etc.
func (wcv *WxCardVisit) Value(name string) (ent.Value, error) {
	return wcv.selectValues.Get(name)
}

// Update returns a builder for updating this WxCardVisit.
// Note that you need to call WxCardVisit.Unwrap() before calling this method if this WxCardVisit
// was returned from a transaction, and the transaction was committed or rolled back.
func (wcv *WxCardVisit) Update() *WxCardVisitUpdateOne {
	return NewWxCardVisitClient(wcv.config).UpdateOne(wcv)
}

// Unwrap unwraps the WxCardVisit entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (wcv *WxCardVisit) Unwrap() *WxCardVisit {
	_tx, ok := wcv.config.driver.(*txDriver)
	if !ok {
		panic("ent: WxCardVisit is not a transactional entity")
	}
	wcv.config.driver = _tx.drv
	return wcv
}

// String implements the fmt.Stringer.
func (wcv *WxCardVisit) String() string {
	var builder strings.Builder
	builder.WriteString("WxCardVisit(")
	builder.WriteString(fmt.Sprintf("id=%v, ", wcv.ID))
	builder.WriteString("created_at=")
	builder.WriteString(wcv.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(wcv.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("deleted_at=")
	builder.WriteString(wcv.DeletedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("user_id=")
	builder.WriteString(fmt.Sprintf("%v", wcv.UserID))
	builder.WriteString(", ")
	builder.WriteString("bot_id=")
	builder.WriteString(fmt.Sprintf("%v", wcv.BotID))
	builder.WriteString(", ")
	builder.WriteString("bot_type=")
	builder.WriteString(fmt.Sprintf("%v", wcv.BotType))
	builder.WriteByte(')')
	return builder.String()
}

// WxCardVisits is a parsable slice of WxCardVisit.
type WxCardVisits []*WxCardVisit
