// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"
	"wechat-api/ent/wxcardvisit"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// WxCardVisitCreate is the builder for creating a WxCardVisit entity.
type WxCardVisitCreate struct {
	config
	mutation *WxCardVisitMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (wcvc *WxCardVisitCreate) SetCreatedAt(t time.Time) *WxCardVisitCreate {
	wcvc.mutation.SetCreatedAt(t)
	return wcvc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableCreatedAt(t *time.Time) *WxCardVisitCreate {
	if t != nil {
		wcvc.SetCreatedAt(*t)
	}
	return wcvc
}

// SetUpdatedAt sets the "updated_at" field.
func (wcvc *WxCardVisitCreate) SetUpdatedAt(t time.Time) *WxCardVisitCreate {
	wcvc.mutation.SetUpdatedAt(t)
	return wcvc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableUpdatedAt(t *time.Time) *WxCardVisitCreate {
	if t != nil {
		wcvc.SetUpdatedAt(*t)
	}
	return wcvc
}

// SetDeletedAt sets the "deleted_at" field.
func (wcvc *WxCardVisitCreate) SetDeletedAt(t time.Time) *WxCardVisitCreate {
	wcvc.mutation.SetDeletedAt(t)
	return wcvc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableDeletedAt(t *time.Time) *WxCardVisitCreate {
	if t != nil {
		wcvc.SetDeletedAt(*t)
	}
	return wcvc
}

// SetUserID sets the "user_id" field.
func (wcvc *WxCardVisitCreate) SetUserID(u uint64) *WxCardVisitCreate {
	wcvc.mutation.SetUserID(u)
	return wcvc
}

// SetNillableUserID sets the "user_id" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableUserID(u *uint64) *WxCardVisitCreate {
	if u != nil {
		wcvc.SetUserID(*u)
	}
	return wcvc
}

// SetBotID sets the "bot_id" field.
func (wcvc *WxCardVisitCreate) SetBotID(u uint64) *WxCardVisitCreate {
	wcvc.mutation.SetBotID(u)
	return wcvc
}

// SetNillableBotID sets the "bot_id" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableBotID(u *uint64) *WxCardVisitCreate {
	if u != nil {
		wcvc.SetBotID(*u)
	}
	return wcvc
}

// SetBotType sets the "bot_type" field.
func (wcvc *WxCardVisitCreate) SetBotType(u uint8) *WxCardVisitCreate {
	wcvc.mutation.SetBotType(u)
	return wcvc
}

// SetNillableBotType sets the "bot_type" field if the given value is not nil.
func (wcvc *WxCardVisitCreate) SetNillableBotType(u *uint8) *WxCardVisitCreate {
	if u != nil {
		wcvc.SetBotType(*u)
	}
	return wcvc
}

// SetID sets the "id" field.
func (wcvc *WxCardVisitCreate) SetID(u uint64) *WxCardVisitCreate {
	wcvc.mutation.SetID(u)
	return wcvc
}

// Mutation returns the WxCardVisitMutation object of the builder.
func (wcvc *WxCardVisitCreate) Mutation() *WxCardVisitMutation {
	return wcvc.mutation
}

// Save creates the WxCardVisit in the database.
func (wcvc *WxCardVisitCreate) Save(ctx context.Context) (*WxCardVisit, error) {
	if err := wcvc.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, wcvc.sqlSave, wcvc.mutation, wcvc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (wcvc *WxCardVisitCreate) SaveX(ctx context.Context) *WxCardVisit {
	v, err := wcvc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (wcvc *WxCardVisitCreate) Exec(ctx context.Context) error {
	_, err := wcvc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (wcvc *WxCardVisitCreate) ExecX(ctx context.Context) {
	if err := wcvc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (wcvc *WxCardVisitCreate) defaults() error {
	if _, ok := wcvc.mutation.CreatedAt(); !ok {
		if wxcardvisit.DefaultCreatedAt == nil {
			return fmt.Errorf("ent: uninitialized wxcardvisit.DefaultCreatedAt (forgotten import ent/runtime?)")
		}
		v := wxcardvisit.DefaultCreatedAt()
		wcvc.mutation.SetCreatedAt(v)
	}
	if _, ok := wcvc.mutation.UpdatedAt(); !ok {
		if wxcardvisit.DefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized wxcardvisit.DefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := wxcardvisit.DefaultUpdatedAt()
		wcvc.mutation.SetUpdatedAt(v)
	}
	if _, ok := wcvc.mutation.UserID(); !ok {
		v := wxcardvisit.DefaultUserID
		wcvc.mutation.SetUserID(v)
	}
	if _, ok := wcvc.mutation.BotID(); !ok {
		v := wxcardvisit.DefaultBotID
		wcvc.mutation.SetBotID(v)
	}
	if _, ok := wcvc.mutation.BotType(); !ok {
		v := wxcardvisit.DefaultBotType
		wcvc.mutation.SetBotType(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (wcvc *WxCardVisitCreate) check() error {
	if _, ok := wcvc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "WxCardVisit.created_at"`)}
	}
	if _, ok := wcvc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "WxCardVisit.updated_at"`)}
	}
	if _, ok := wcvc.mutation.BotID(); !ok {
		return &ValidationError{Name: "bot_id", err: errors.New(`ent: missing required field "WxCardVisit.bot_id"`)}
	}
	if _, ok := wcvc.mutation.BotType(); !ok {
		return &ValidationError{Name: "bot_type", err: errors.New(`ent: missing required field "WxCardVisit.bot_type"`)}
	}
	return nil
}

func (wcvc *WxCardVisitCreate) sqlSave(ctx context.Context) (*WxCardVisit, error) {
	if err := wcvc.check(); err != nil {
		return nil, err
	}
	_node, _spec := wcvc.createSpec()
	if err := sqlgraph.CreateNode(ctx, wcvc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = uint64(id)
	}
	wcvc.mutation.id = &_node.ID
	wcvc.mutation.done = true
	return _node, nil
}

func (wcvc *WxCardVisitCreate) createSpec() (*WxCardVisit, *sqlgraph.CreateSpec) {
	var (
		_node = &WxCardVisit{config: wcvc.config}
		_spec = sqlgraph.NewCreateSpec(wxcardvisit.Table, sqlgraph.NewFieldSpec(wxcardvisit.FieldID, field.TypeUint64))
	)
	_spec.OnConflict = wcvc.conflict
	if id, ok := wcvc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := wcvc.mutation.CreatedAt(); ok {
		_spec.SetField(wxcardvisit.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := wcvc.mutation.UpdatedAt(); ok {
		_spec.SetField(wxcardvisit.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := wcvc.mutation.DeletedAt(); ok {
		_spec.SetField(wxcardvisit.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if value, ok := wcvc.mutation.UserID(); ok {
		_spec.SetField(wxcardvisit.FieldUserID, field.TypeUint64, value)
		_node.UserID = value
	}
	if value, ok := wcvc.mutation.BotID(); ok {
		_spec.SetField(wxcardvisit.FieldBotID, field.TypeUint64, value)
		_node.BotID = value
	}
	if value, ok := wcvc.mutation.BotType(); ok {
		_spec.SetField(wxcardvisit.FieldBotType, field.TypeUint8, value)
		_node.BotType = value
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.WxCardVisit.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.WxCardVisitUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (wcvc *WxCardVisitCreate) OnConflict(opts ...sql.ConflictOption) *WxCardVisitUpsertOne {
	wcvc.conflict = opts
	return &WxCardVisitUpsertOne{
		create: wcvc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (wcvc *WxCardVisitCreate) OnConflictColumns(columns ...string) *WxCardVisitUpsertOne {
	wcvc.conflict = append(wcvc.conflict, sql.ConflictColumns(columns...))
	return &WxCardVisitUpsertOne{
		create: wcvc,
	}
}

type (
	// WxCardVisitUpsertOne is the builder for "upsert"-ing
	//  one WxCardVisit node.
	WxCardVisitUpsertOne struct {
		create *WxCardVisitCreate
	}

	// WxCardVisitUpsert is the "OnConflict" setter.
	WxCardVisitUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *WxCardVisitUpsert) SetUpdatedAt(v time.Time) *WxCardVisitUpsert {
	u.Set(wxcardvisit.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *WxCardVisitUpsert) UpdateUpdatedAt() *WxCardVisitUpsert {
	u.SetExcluded(wxcardvisit.FieldUpdatedAt)
	return u
}

// SetDeletedAt sets the "deleted_at" field.
func (u *WxCardVisitUpsert) SetDeletedAt(v time.Time) *WxCardVisitUpsert {
	u.Set(wxcardvisit.FieldDeletedAt, v)
	return u
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *WxCardVisitUpsert) UpdateDeletedAt() *WxCardVisitUpsert {
	u.SetExcluded(wxcardvisit.FieldDeletedAt)
	return u
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *WxCardVisitUpsert) ClearDeletedAt() *WxCardVisitUpsert {
	u.SetNull(wxcardvisit.FieldDeletedAt)
	return u
}

// SetUserID sets the "user_id" field.
func (u *WxCardVisitUpsert) SetUserID(v uint64) *WxCardVisitUpsert {
	u.Set(wxcardvisit.FieldUserID, v)
	return u
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *WxCardVisitUpsert) UpdateUserID() *WxCardVisitUpsert {
	u.SetExcluded(wxcardvisit.FieldUserID)
	return u
}

// AddUserID adds v to the "user_id" field.
func (u *WxCardVisitUpsert) AddUserID(v uint64) *WxCardVisitUpsert {
	u.Add(wxcardvisit.FieldUserID, v)
	return u
}

// ClearUserID clears the value of the "user_id" field.
func (u *WxCardVisitUpsert) ClearUserID() *WxCardVisitUpsert {
	u.SetNull(wxcardvisit.FieldUserID)
	return u
}

// SetBotID sets the "bot_id" field.
func (u *WxCardVisitUpsert) SetBotID(v uint64) *WxCardVisitUpsert {
	u.Set(wxcardvisit.FieldBotID, v)
	return u
}

// UpdateBotID sets the "bot_id" field to the value that was provided on create.
func (u *WxCardVisitUpsert) UpdateBotID() *WxCardVisitUpsert {
	u.SetExcluded(wxcardvisit.FieldBotID)
	return u
}

// AddBotID adds v to the "bot_id" field.
func (u *WxCardVisitUpsert) AddBotID(v uint64) *WxCardVisitUpsert {
	u.Add(wxcardvisit.FieldBotID, v)
	return u
}

// SetBotType sets the "bot_type" field.
func (u *WxCardVisitUpsert) SetBotType(v uint8) *WxCardVisitUpsert {
	u.Set(wxcardvisit.FieldBotType, v)
	return u
}

// UpdateBotType sets the "bot_type" field to the value that was provided on create.
func (u *WxCardVisitUpsert) UpdateBotType() *WxCardVisitUpsert {
	u.SetExcluded(wxcardvisit.FieldBotType)
	return u
}

// AddBotType adds v to the "bot_type" field.
func (u *WxCardVisitUpsert) AddBotType(v uint8) *WxCardVisitUpsert {
	u.Add(wxcardvisit.FieldBotType, v)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(wxcardvisit.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *WxCardVisitUpsertOne) UpdateNewValues() *WxCardVisitUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(wxcardvisit.FieldID)
		}
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(wxcardvisit.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *WxCardVisitUpsertOne) Ignore() *WxCardVisitUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *WxCardVisitUpsertOne) DoNothing() *WxCardVisitUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the WxCardVisitCreate.OnConflict
// documentation for more info.
func (u *WxCardVisitUpsertOne) Update(set func(*WxCardVisitUpsert)) *WxCardVisitUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&WxCardVisitUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *WxCardVisitUpsertOne) SetUpdatedAt(v time.Time) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *WxCardVisitUpsertOne) UpdateUpdatedAt() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *WxCardVisitUpsertOne) SetDeletedAt(v time.Time) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *WxCardVisitUpsertOne) UpdateDeletedAt() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *WxCardVisitUpsertOne) ClearDeletedAt() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.ClearDeletedAt()
	})
}

// SetUserID sets the "user_id" field.
func (u *WxCardVisitUpsertOne) SetUserID(v uint64) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetUserID(v)
	})
}

// AddUserID adds v to the "user_id" field.
func (u *WxCardVisitUpsertOne) AddUserID(v uint64) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *WxCardVisitUpsertOne) UpdateUserID() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateUserID()
	})
}

// ClearUserID clears the value of the "user_id" field.
func (u *WxCardVisitUpsertOne) ClearUserID() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.ClearUserID()
	})
}

// SetBotID sets the "bot_id" field.
func (u *WxCardVisitUpsertOne) SetBotID(v uint64) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetBotID(v)
	})
}

// AddBotID adds v to the "bot_id" field.
func (u *WxCardVisitUpsertOne) AddBotID(v uint64) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddBotID(v)
	})
}

// UpdateBotID sets the "bot_id" field to the value that was provided on create.
func (u *WxCardVisitUpsertOne) UpdateBotID() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateBotID()
	})
}

// SetBotType sets the "bot_type" field.
func (u *WxCardVisitUpsertOne) SetBotType(v uint8) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetBotType(v)
	})
}

// AddBotType adds v to the "bot_type" field.
func (u *WxCardVisitUpsertOne) AddBotType(v uint8) *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddBotType(v)
	})
}

// UpdateBotType sets the "bot_type" field to the value that was provided on create.
func (u *WxCardVisitUpsertOne) UpdateBotType() *WxCardVisitUpsertOne {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateBotType()
	})
}

// Exec executes the query.
func (u *WxCardVisitUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for WxCardVisitCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *WxCardVisitUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *WxCardVisitUpsertOne) ID(ctx context.Context) (id uint64, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *WxCardVisitUpsertOne) IDX(ctx context.Context) uint64 {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// WxCardVisitCreateBulk is the builder for creating many WxCardVisit entities in bulk.
type WxCardVisitCreateBulk struct {
	config
	err      error
	builders []*WxCardVisitCreate
	conflict []sql.ConflictOption
}

// Save creates the WxCardVisit entities in the database.
func (wcvcb *WxCardVisitCreateBulk) Save(ctx context.Context) ([]*WxCardVisit, error) {
	if wcvcb.err != nil {
		return nil, wcvcb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(wcvcb.builders))
	nodes := make([]*WxCardVisit, len(wcvcb.builders))
	mutators := make([]Mutator, len(wcvcb.builders))
	for i := range wcvcb.builders {
		func(i int, root context.Context) {
			builder := wcvcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*WxCardVisitMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, wcvcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = wcvcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, wcvcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = uint64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, wcvcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (wcvcb *WxCardVisitCreateBulk) SaveX(ctx context.Context) []*WxCardVisit {
	v, err := wcvcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (wcvcb *WxCardVisitCreateBulk) Exec(ctx context.Context) error {
	_, err := wcvcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (wcvcb *WxCardVisitCreateBulk) ExecX(ctx context.Context) {
	if err := wcvcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.WxCardVisit.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.WxCardVisitUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (wcvcb *WxCardVisitCreateBulk) OnConflict(opts ...sql.ConflictOption) *WxCardVisitUpsertBulk {
	wcvcb.conflict = opts
	return &WxCardVisitUpsertBulk{
		create: wcvcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (wcvcb *WxCardVisitCreateBulk) OnConflictColumns(columns ...string) *WxCardVisitUpsertBulk {
	wcvcb.conflict = append(wcvcb.conflict, sql.ConflictColumns(columns...))
	return &WxCardVisitUpsertBulk{
		create: wcvcb,
	}
}

// WxCardVisitUpsertBulk is the builder for "upsert"-ing
// a bulk of WxCardVisit nodes.
type WxCardVisitUpsertBulk struct {
	create *WxCardVisitCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(wxcardvisit.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *WxCardVisitUpsertBulk) UpdateNewValues() *WxCardVisitUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(wxcardvisit.FieldID)
			}
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(wxcardvisit.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.WxCardVisit.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *WxCardVisitUpsertBulk) Ignore() *WxCardVisitUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *WxCardVisitUpsertBulk) DoNothing() *WxCardVisitUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the WxCardVisitCreateBulk.OnConflict
// documentation for more info.
func (u *WxCardVisitUpsertBulk) Update(set func(*WxCardVisitUpsert)) *WxCardVisitUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&WxCardVisitUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *WxCardVisitUpsertBulk) SetUpdatedAt(v time.Time) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *WxCardVisitUpsertBulk) UpdateUpdatedAt() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *WxCardVisitUpsertBulk) SetDeletedAt(v time.Time) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *WxCardVisitUpsertBulk) UpdateDeletedAt() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *WxCardVisitUpsertBulk) ClearDeletedAt() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.ClearDeletedAt()
	})
}

// SetUserID sets the "user_id" field.
func (u *WxCardVisitUpsertBulk) SetUserID(v uint64) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetUserID(v)
	})
}

// AddUserID adds v to the "user_id" field.
func (u *WxCardVisitUpsertBulk) AddUserID(v uint64) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *WxCardVisitUpsertBulk) UpdateUserID() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateUserID()
	})
}

// ClearUserID clears the value of the "user_id" field.
func (u *WxCardVisitUpsertBulk) ClearUserID() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.ClearUserID()
	})
}

// SetBotID sets the "bot_id" field.
func (u *WxCardVisitUpsertBulk) SetBotID(v uint64) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetBotID(v)
	})
}

// AddBotID adds v to the "bot_id" field.
func (u *WxCardVisitUpsertBulk) AddBotID(v uint64) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddBotID(v)
	})
}

// UpdateBotID sets the "bot_id" field to the value that was provided on create.
func (u *WxCardVisitUpsertBulk) UpdateBotID() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateBotID()
	})
}

// SetBotType sets the "bot_type" field.
func (u *WxCardVisitUpsertBulk) SetBotType(v uint8) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.SetBotType(v)
	})
}

// AddBotType adds v to the "bot_type" field.
func (u *WxCardVisitUpsertBulk) AddBotType(v uint8) *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.AddBotType(v)
	})
}

// UpdateBotType sets the "bot_type" field to the value that was provided on create.
func (u *WxCardVisitUpsertBulk) UpdateBotType() *WxCardVisitUpsertBulk {
	return u.Update(func(s *WxCardVisitUpsert) {
		s.UpdateBotType()
	})
}

// Exec executes the query.
func (u *WxCardVisitUpsertBulk) Exec(ctx context.Context) error {
	if u.create.err != nil {
		return u.create.err
	}
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the WxCardVisitCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for WxCardVisitCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *WxCardVisitUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
