package hook

type GetChatrooMmemberDetailReq struct {
	Gid string `json:"gid"`
}

type GetChatrooMmemberDetailReap struct {
	Member []ChatrooMmemberDetail `json:"member"`
}

type ChatrooMmemberDetail struct {
	Wxid          string `json:"wxid"`
	Nickname      string `json:"nickname"`
	UserHeadBig   string `json:"user_head_big"`
	UserHeadSmall string `json:"user_head_small"`
	UserFlag      string `json:"user_flag"`
	InviterWxid   string `json:"inviter_wxid"`
}

type GetChatroomMemberDetailInfoReq struct {
	Gid  string `json:"gid"`
	Wxid string `json:"wxid"`
}

type GetChatroomMemberDetailInfoReap struct {
	Type          string `json:"type"`
	Wxid          string `json:"wxid"`
	Nickname      string `json:"nickname"`
	Sex           string `json:"sex"`
	Source        string `json:"source"`
	Province      string `json:"province"`
	Area          string `json:"area"`
	Signinfo      string `json:"signinfo"`
	Wxaccount     string `json:"wxaccount"`
	Md5           string `json:"Md5"`
	Timelinebgurl string `json:"timelinebgurl"`
	Country       string `json:"country"`
	Headurl       string `json:"headurl"`
	HeadImgMd5    string `json:"headImgMd5"`
	V3            string `json:"v3"`
	Fromchatroom  string `json:"fromchatroom"`
	V4            string `json:"v4"`
}

type AddNewFriendReq struct {
	V3Wxid  string `json:"v3_wxid"`
	V4      string `json:"v4"`
	Desc    string `json:"desc"`
	AddType string `json:"type"`
	Role    string `json:"role"`
}

type AddNewFriendReap struct {
	Status string `json:"Status"`
	RetTxt string `json:"RetTxt"`
	RetV3  string `json:"ret_v3"`
}

type BatchGetContactBriefInfoReq struct {
	WxidList string `json:"wxidlist"`
}

type BriefInfo struct {
	Wxid      string `json:"wxid"`
	WXAccount string `json:"wx_account"`
	Status    string `json:"status"`
	Nickname  string `json:"nickname"`
	Markname  string `json:"markname"`
	Country   string `json:"country"`
	Province  string `json:"province"`
	City      string `json:"city"`
	Sex       string `json:"sex"`
	Bighead   string `json:"bighead"`
	Smallhead string `json:"smallhead"`
	Labeltag  string `json:"labeltag"`
}

type BatchGetContactBriefInfoReap struct {
	Count string      `json:"count"`
	Info  []BriefInfo `json:"info"`
}

type GetBatchGetChatRoomMemberWxidReq struct {
	Gid string `json:"gid"`
}

type GetBatchGetChatRoomMemberWxidReap struct {
	Data []struct {
		Wxid string `json:"wxid"`
	} `json:"data"`
}

type GetContactLabelListReap struct {
	Label []struct {
		Id   string `json:"id"`
		Name string `json:"name"`
	}
}

type GetFriendAndChatRoomListReq struct {
	Type string `json:"type"`
}

type GetFriendAndChatRoomListReap struct {
	CountFriend string `json:"count_friend"`
	Friend      []struct {
		Index     string `json:"index"`
		Wxid      string `json:"wxid"`
		Account   string `json:"account"`
		Nickname  string `json:"nickname"`
		V3        string `json:"v3"`
		Markname  string `json:"markname"`
		Starrole  string `json:"starrole"`
		Dontseeit string `json:"dontseeit"`
		Dontseeme string `json:"dontseeme"`
		Headimg   string `json:"headimg"`
		Sex       string `json:"sex"`
		Lag       string `json:"lag"`
	} `json:"friend"`
	CountChatroom string `json:"count_chatroom"`
	Chatroom      []struct {
		Index    string `json:"index"`
		Gid      string `json:"gid"`
		Gname    string `json:"gname"`
		Markname string `json:"markname"`
		V3       string `json:"v3"`
	} `json:"chatroom"`
	CountGh string `json:"count_gh"`
	Gh      []struct {
		Index    string `json:"index"`
		Wxid     string `json:"wxid"`
		Account  string `json:"account"`
		Nickname string `json:"nickname"`
		Markname string `json:"markname"`
		V3       string `json:"v3"`
	} `json:"gh"`
}

type ConfigureMsgReciveReq struct {
	IsEnable string `json:"isEnable"`
	URL      string `json:"url"`
}

type SendTextMsgReq struct {
	Wxid string `json:"wxid"`
	Msg  string `json:"msg"`
}

type SendPicMsgReq struct {
	Wxid        string `json:"wxid"`
	Picpath     string `json:"picpath"`
	Diyfilename string `json:"diyfilename"`
}

type SendPicMsgLocalReq struct {
	Wxid    string `json:"wxid"`
	Picpath string `json:"picpath"`
}

type GetSelfLoginInfoResp struct {
	ProcessID string `json:"ProcessID"`
	Wxid      string `json:"wxid"`
	Account   string `json:"account"`
	Nickname  string `json:"nickname"`
	Tel       string `json:"tel"`
	Country   string `json:"country"`
	Province  string `json:"province"`
	City      string `json:"city"`
	HeadBig   string `json:"head_big"`
	DiySign   string `json:"diy_sign"`
}

type LogoutResp struct {
	Code string `json:"code"`
	Msg  string `json:"msg"`
}

type GetWeChatProcessNumberResp struct {
	TotalNum string `json:"total_num"`
	List     []struct {
		Index       int    `json:"Index"`
		ProcessName string `json:"ProcessName"`
		PID         int    `json:"PID"`
		Par         string `json:"Par"`
		Port        int    `json:"Port"`
	} `json:"List"`
}

type GetLoginQRCodeReap struct {
	Base64 string `json:"base64"`
}

type IsLoginStatusResp struct {
	Onlinestatus string `json:"onlinestatus"`
	Msg          string `json:"msg"`
	LoginLoading string `json:"login_loading"`
	Selfwxid     string `json:"selfwxid"`
	Nickname     string `json:"nickname"`
}

type GetPortOccupiedInfoReq struct {
	CheckPort string `json:"CheckPort"`
}

type GetPortOccupiedInfoResp struct {
	Occupied string `json:"Occupied"`
}

type StartWechatReq struct {
	StartPort string `json:"StartPort"`
}

type TerminateThisWeChatReq struct {
	PID string `json:"PID"`
}

type StartWechatResp struct {
	StartPort string `json:"StartPort"`
	Success   string `json:"success"`
}

type ClickLoginButtonResp struct {
	ClickLoginButton string `json:"ClickLoginButton"`
}
