package Wx

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/Wx"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /wx/check Wx CheckWx
//
// Check wx information | 检查并更新Wx状态
//
// Check wx information | 检查并更新Wx状态
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: WxInfo
//
// Responses:
//  200: BaseMsgResp

func CheckWxHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.WxInfo
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := Wx.NewCheckWxLogic(r.Context(), svcCtx)
		resp, err := l.CheckWx(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
