package sop_task

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/sop_task"
	"wechat-api/internal/svc"
)

// swagger:route post /api/sop_task/list sop_task GetApiSopTaskList
//
// Get sop task list | 获取SopTask列表
//
// Get sop task list | 获取SopTask列表
//
// Responses:
//  200: SopTaskListResp

func GetApiSopTaskListHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		l := sop_task.NewGetApiSopTaskListLogic(r.Context(), svcCtx)
		resp, err := l.GetApiSopTaskList(r)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
