package work_experience

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/work_experience"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /work_experience/update work_experience UpdateWorkExperience
//
// Update work experience information | 更新WorkExperience
//
// Update work experience information | 更新WorkExperience
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: WorkExperienceInfo
//
// Responses:
//  200: BaseMsgResp

func UpdateWorkExperienceHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.WorkExperienceInfo
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := work_experience.NewUpdateWorkExperienceLogic(r.Context(), svcCtx)
		resp, err := l.UpdateWorkExperience(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
